<?php
/**
 * @package        Arastta eCommerce
 * @copyright      Copyright (C) 2015-2016 Arastta Association. All rights reserved. (arastta.org)
 * @credits        See CREDITS.txt for credits and other copyright notices.
 * @license        GNU General Public License version 3; see LICENSE.txt
 */
 
# VERSION = the current version
# $version = the version to be updated

// 1.4.0 changes;
    // Update banner_image table
    $this->db->query("ALTER TABLE `" . DB_PREFIX . "banner_image` ADD `language_id` INT(11) NOT NULL AFTER `banner_id`");
    $this->db->query("ALTER TABLE `" . DB_PREFIX . "banner_image`  ADD `title` VARCHAR( 64 ) NOT NULL AFTER `language_id`");

    $banners = $this->db->query("SELECT * FROM " . DB_PREFIX . "banner WHERE 1");

    if ($banners->num_rows) {
        $banner_image_data = array();

        foreach ($banners->rows as $banner) {
            $banner_image_query = $this->db->query("SELECT * FROM " . DB_PREFIX . "banner_image WHERE banner_id = '" . (int)$banner['banner_id'] . "' ORDER BY sort_order ASC");

            foreach ($banner_image_query->rows as $banner_image) {
                $banner_image_description_query = $this->db->query("SELECT * FROM " . DB_PREFIX . "banner_image_description WHERE banner_image_id = '" . (int)$banner_image['banner_image_id'] . "' AND banner_id = '" . (int)$banner['banner_id'] . "'");

                foreach ($banner_image_description_query->rows as $banner_image_description) {
                    $banner_image_data[$banner['banner_id']][$banner_image_description['language_id']][] = array(
                        'banner_id'  => $banner['banner_id'],
                        'title'      => $banner_image_description['title'],
                        'link'       => $banner_image['link'],
                        'image'      => $banner_image['image'],
                        'sort_order' => $banner_image['sort_order']
                    );
                }
            }
        }

        // Truncate banner_image table
        $this->db->query("TRUNCATE `" . DB_PREFIX . "banner_image`");

        if ($banner_image_data) {
            foreach ($banner_image_data as $banner_id => $banner_image_value) {
                foreach ($banner_image_value as $language_id => $value) {
                    foreach ($value as $banner_image) {
                        $this->db->query("INSERT INTO " . DB_PREFIX . "banner_image SET banner_id = '" . (int)$banner_id . "', language_id = '" . (int)$language_id . "', title = '" .  $this->db->escape($banner_image['title']) . "', link = '" .  $this->db->escape($banner_image['link']) . "', image = '" .  $this->db->escape($banner_image['image']) . "', sort_order = '" .  (int)$banner_image['sort_order'] . "'");
                    }
                }
            }
        }
    }

    // Delete banner_image_description table
    $this->db->query("DROP TABLE `" . DB_PREFIX . "banner_image_description`");

    // Customer Search
    $this->db->query("CREATE TABLE IF NOT EXISTS `" . DB_PREFIX . "customer_search` (
  `customer_search_id` int(11) NOT NULL AUTO_INCREMENT,
  `store_id` int(11) NOT NULL,
  `language_id` int(11) NOT NULL,
  `customer_id` int(11) NOT NULL,
  `keyword` varchar(255) NOT NULL,
  `category_id` int(11),
  `sub_category` tinyint(1) NOT NULL,
  `description` tinyint(1) NOT NULL,
  `products` int(11) NOT NULL,
  `ip` varchar(40) NOT NULL,
  `date_added` datetime NOT NULL,
  PRIMARY KEY (`customer_search_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_general_ci;");

    // Insert setting table
    $this->db->query("INSERT INTO " . DB_PREFIX . "setting SET `store_id` = 0, `code` = 'config', `key` = 'config_customer_search', `value` = '0', `serialized` = 0");

    // Update user groups
    $user_groups = $this->db->query("SELECT DISTINCT * FROM " . DB_PREFIX . "user_group");

    foreach ($user_groups->rows as $user_group) {
        $user_group['permission'] = unserialize($user_group['permission']);

        $user_group['permission']['access'][] = 'report/customer_search';
        $user_group['permission']['modify'][] = 'report/customer_search';

        $this->db->query("UPDATE " . DB_PREFIX . "user_group SET name = '" . $this->db->escape($user_group['name']) . "', permission = '" . $this->db->escape(serialize($user_group['permission'])) . "' WHERE user_group_id = '" . (int)$user_group['user_group_id'] . "'");
    }

// 1.4.1 changes;
    $this->db->query("INSERT INTO " . DB_PREFIX . "setting SET store_id = '0', `code` = 'config', `key` = 'config_customer_activity', `value` = '0'");
    $this->db->query("INSERT INTO " . DB_PREFIX . "setting SET store_id = '0', `code` = 'config', `key` = 'config_affiliate_activity', `value` = '0'");

// 1.5.0 changes;
    // Update the user groups
    $user_groups = $this->db->query("SELECT DISTINCT * FROM " . DB_PREFIX . "user_group");

    foreach ($user_groups->rows as $user_group) {
        $user_group['permission'] = unserialize($user_group['permission']);
        
        $user_group['permission']['access'][] = 'tool/cache';
        $user_group['permission']['modify'][] = 'tool/cache';

        $user_group['permission']['access'][] = 'report/graph';
        $user_group['permission']['modify'][] = 'report/graph';

        $user_group['permission']['access'][] = 'system/url_manager';
        $user_group['permission']['modify'][] = 'system/url_manager';

        $user_group['permission']['access'][] = 'analytics/google';
        $user_group['permission']['modify'][] = 'analytics/google';

        $user_group['permission']['access'][] = 'analytics/woopra';
        $user_group['permission']['modify'][] = 'analytics/woopra';

        $user_group['permission']['access'][] = 'antifraud/maxmind';
        $user_group['permission']['modify'][] = 'antifraud/maxmind';

        $user_group['permission']['access'][] = 'captcha/basic';
        $user_group['permission']['modify'][] = 'captcha/basic';

        $user_group['permission']['access'][] = 'captcha/google';
        $user_group['permission']['modify'][] = 'captcha/google';

        $this->db->query("UPDATE " . DB_PREFIX . "user_group SET name = '" . $this->db->escape($user_group['name']) . "', permission = '" . $this->db->escape(serialize($user_group['permission'])) . "' WHERE user_group_id = '" . (int)$user_group['user_group_id'] . "'");
    }
    
    // Create user_activity table
    $this->db->query("CREATE TABLE IF NOT EXISTS `" . DB_PREFIX . "user_activity` (
        `activity_id` int(11) NOT NULL AUTO_INCREMENT,
        `user_id` int(11) NOT NULL,
        `key` varchar(64) NOT NULL,
        `data` text NOT NULL,
        `ip` varchar(40) NOT NULL,
        `date_added` datetime NOT NULL,
        PRIMARY KEY (`activity_id`),
        KEY `user_id` (`user_id`)
        ) DEFAULT CHARSET=utf8 COLLATE=utf8_general_ci;");

    // Update stock_status table
    $this->db->query("ALTER TABLE `" . DB_PREFIX . "stock_status` ADD `preorder` TINYINT( 1 ) NOT NULL DEFAULT '0' AFTER `color`");

    // Add maintenance display settings
    $this->db->query("INSERT INTO " . DB_PREFIX . "setting SET store_id = '0', `code` = 'config', `key` = 'config_maintenance_message', `value` = ''");
    $this->db->query("INSERT INTO " . DB_PREFIX . "setting SET store_id = '0', `code` = 'config', `key` = 'config_maintenance_image', `value` = ''");
    $this->db->query("INSERT INTO " . DB_PREFIX . "setting SET store_id = '0', `code` = 'config', `key` = 'config_maintenance_login', `value` = '1'");
    $this->db->query("INSERT INTO " . DB_PREFIX . "setting SET store_id = '0', `code` = 'config', `key` = 'config_image_maintenance_width', `value` = '268'");
    $this->db->query("INSERT INTO " . DB_PREFIX . "setting SET store_id = '0', `code` = 'config', `key` = 'config_image_maintenance_height', `value` = '50'");
    
    // Update config for new extension types: analytics, anti-fraud, captcha
    $this->load->model('setting/setting');
    
    $store_id = $this->config->get('config_store_id');
    
    $config = $this->model_setting_setting->getSetting('config', $store_id);
    
    if ($this->config->get('config_google_captcha_status')) {
        $data = array();
        $data['google_captcha_status'] = '1';
        $data['google_captcha_public'] = $this->config->get('config_google_captcha_public');
        $data['google_captcha_secret'] = $this->config->get('config_google_captcha_secret');
        
        $this->model_setting_setting->editSetting('google_captcha', $data, $store_id);
        
        $config['config_captcha'] = 'google';
        
        $this->model_setting_setting->editSetting('config', $config, $store_id);
    } else {
        $config['config_captcha'] = '';
        
        $this->model_setting_setting->editSetting('config', $config, $store_id);
    }
    
    if ($this->config->get('config_google_analytics_status')) {
        $data = array();
        $data['google_analytics_status'] = '1';
        $data['google_analytics_code'] = $this->config->get('config_google_analytics');
        
        $this->model_setting_setting->editSetting('google_analytics', $data, $store_id);
    }
    
    if ($this->config->get('config_fraud_detection')) {
        $data = array();
        $data['maxmind_antifraud_status'] = '1';
        $data['maxmind_antifraud_key'] = $this->config->get('config_fraud_key');
        $data['maxmind_antifraud_score'] = $this->config->get('config_fraud_score');
        $data['maxmind_antifraud_status_id'] = $this->config->get('config_fraud_status_id');
        
        $this->model_setting_setting->editSetting('maxmind_antifraud', $data, $store_id);
    }
